package database

import org.ktorm.database.Database
import org.ktorm.entity.Entity
import org.ktorm.entity.sequenceOf
import org.ktorm.schema.Table
import org.ktorm.schema.int
import org.ktorm.schema.varchar

val Database.card get() = this.sequenceOf(TCards)

interface TCard : Entity<TCard> {
    companion object : Entity.Factory<TCard>()

    val id: Int
    val name: String
    val characterId: Int
    val characterName: String
    val type: String
    val rarity: String
    val maxLevel: String
    val maxHp: String
    val smile: String
    val pure: String
    val cool: String
    val illustId: String
    val evolveIllustId: String
    val group: String
    val team: String
    val date: String
    val centerSkillName: String
    val centerSkillInfo: String
    val specialSkillName: String
    val specialSkillInfo: String
}

object TCards : Table<TCard>("t_card") {
    val id = int("id").primaryKey().bindTo { it.id }
    val name = varchar("name").bindTo { it.name }
    val characterId = int("character_id").bindTo { it.characterId }
    val characterName = varchar("character_name").bindTo { it.characterName }
    val type = varchar("type").bindTo { it.type }
    val rarity = varchar("rarity").bindTo { it.rarity }
    val maxLevel = varchar("max_level").bindTo { it.maxLevel }
    val maxHp = varchar("max_hp").bindTo { it.maxHp }
    val smile = varchar("smile").bindTo { it.smile }
    val pure = varchar("pure").bindTo { it.pure }
    val cool = varchar("cool").bindTo { it.cool }
    val illustId = varchar("illust_id").bindTo { it.illustId }
    val evolveIllustId = varchar("evolve_illust_id").bindTo { it.evolveIllustId }
    val group = varchar("group").bindTo { it.group }
    val team = varchar("team").bindTo { it.team }
    val date = varchar("date").bindTo { it.date }
    val centerSkillName = varchar("center_skill_name").bindTo { it.centerSkillName }
    val centerSkillInfo = varchar("center_skill_info").bindTo { it.centerSkillInfo }
    val specialSkillName = varchar("special_skill_name").bindTo { it.specialSkillName }
    val specialSkillInfo = varchar("special_skill_info").bindTo { it.specialSkillInfo }
}